variables:
  PYTHON_CI_MYPY: 1
  PYTHON_CI_LINT: 1
  PYTHON_CI_TEST: 1
  PYTHON_CI_STYLE: 1
  PYTHON_CI_STYLE_MAX_FILES_DIFF: 15
  PYTHON_CI_DOCKER: 1

style_py_black:
  image: bananwhite98/python
  stage: test
  interruptible: true
  cache:
    key: venv
    paths:
      - .venv/
  artifacts:
    paths:
      - format.patch
    when: on_failure
    expose_as: "Python black format patch"
  rules:
    - if: '$PYTHON_CI_STYLE == "1" && $CI_PIPELINE_SOURCE == "merge_request_event"'
    - if: '$PYTHON_CI_STYLE == "1" && $CI_PIPELINE_SOURCE == "web"'
  script:
    - black --version
    - make format
    - count=$(git ls-files --modified | wc -l)
    - |
      if [[ ${count} -gt 0 ]]; then
        if [[ ${count} -le ${PYTHON_CI_STYLE_MAX_FILES_DIFF} ]]; then
          git diff > format.patch
          PAGER= git diff --color=always
        else
          git ls-files --modified;
        fi
        exit 1
      fi

test_py:
  image: bananwhite98/python
  stage: test
  interruptible: true
  coverage: "/Coverage: ([0-9]{1,3}/"
  rules:
    - if: '$PYTHON_CI_TEST == "1" && $CI_PIPELINE_SOURCE == "merge_request_event"'
    - if: '$PYTHON_CI_TEST == "1" && $CI_PIPELINE_SOURCE == "web"'
  cache:
    key: venv
    paths:
      - ./venv
  artifacts:
    reports:
      junit: build/pytest-junit.xml
      coverage_report:
        coverage_format: cobertura
        path: build/coverage.xml
  script:
    - make test-cov
    - cov=$(grep -oP 'line-rate="\K[^"]+' build/coverage.xml | head -n1)
    - python -c "print('Coverage:', int(${cov} * 100))"

lint_py_mypy:
  image: bananwhite98/python
  stage: test
  interruptible: true
  rules:
    - if: '$PYTHON_CI_MYPY == "1" && $CI_PIPELINE_SOURCE == "merge_request_event"'
    - if: '$PYTHON_CI_MYPY == "1" && $CI_PIPELINE_SOURCE == "web"'
  cache:
    key: venv
    paths:
      - .venv/
  script:
    - make mypy

lint_py:
  image: bananwhite98/python
  stage: test
  interruptible: true
  rules:
    - if: '$PYTHON_CI_LINT == "1" && $CI_PIPELINE_SOURCE == "merge_request_event"'
    - if: '$PYTHON_CI_LINT == "1" && $CI_PIPELINE_SOURCE == "web"'
  cache:
    key: venv
    paths:
      - .venv/
  artifacts:
    reports:
      codequality: build/codeclimate.json
  script:
    - make lint || exit 0
    - pylint2codeclimate.py -- input build/pylint.json --output build/codeclimate.json

docker_py:
  image: bananwhite98/python
  stage: deploy
  rules:
    - if: '$PYTHON_CI_DOCKER == "1" && $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH'
    - if: '$PYTHON_CI_DOCKER == "1" && $CI_PIPELINE_SOURCE == "web"'
  before_script:
    - >
      docker login -u ${DOCKER_HUB_USERNAME} -p ${DOCKER_HUB_PASSWORD}
  script:
    - make docker-build
    - make docker-push
    - make docker-rmi
